import React, { ReactNode } from "react";
import { MDXProvider } from "@mdx-js/react";
import { Image } from "../../components/Image";
import ElectionContent from "../../content/meet-the-team/elections.mdx";
import styles from "./team.module.css";
import { TeamMemberCard } from "../../components/TeamMemberCard";
// import fs from "fs";
import { InferGetStaticPropsType } from "next";
import dynamic from "next/dynamic";

const execsPath = "content/meet-the-team/execs/";

export default function MeetTheTeam(
  props: InferGetStaticPropsType<typeof getStaticProps>
) {
  const components = props.files.map((file) =>
    dynamic(() => import("../../" + execsPath + file))
  );

  return (
    <MDXProvider components={{}}>
      <div className={styles.container}>
        <div className={styles.headerContainer}>
          <h1 className={styles.header}>Meet the Team!</h1>
          <Image src="meet-the-team/team-codey.svg" className={styles.codey} />
        </div>
        <div className={styles.execs}>
          <h2 className={styles.subheading}>The Executives</h2>
          {console.log(components)}
          {/* {props.execs.map((exec) => {
            return (
              <div key={exec.metadata.name}>
                <TeamMemberCard {...exec.metadata}>
                  {exec.content}
                </TeamMemberCard>
              </div>
            );
          })} */}
        </div>
        <div className={styles.programme}>
          <h2 className={styles.subheading}>Programme Committee</h2>
        </div>
        <div className={styles.website}>
          <h2 className={styles.subheading}>Website Committee</h2>
        </div>
        <div className={styles.system}>
          <h2 className={styles.subheading}>Systems Committee</h2>
        </div>
        <div className={styles.other}>
          <h2 className={styles.subheading}>Other Positions</h2>
        </div>
        <div className={styles.elections}>
          <h2 className={styles.electionSubheading}>Elections</h2>
          <ElectionContent />
        </div>
      </div>
    </MDXProvider>
  );
}

interface ExecProps {
  content: ReactNode;
  metadata: { name: string; role: string; image?: string };
}

export async function getStaticProps() {
  // const execs: ExecProps[] = [];
  const fs = require("fs");
  const files = fs.readdirSync(execsPath);
  console.log(files);
  // files.map(async (file: string) => {
  //   // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment
  //   const exec = await import("../../" + execsPath + file);
  //   exec.content = <exec.default />;
  //   execs.push(exec);
  // });
  return { props: { files } };
}
